import Title from "@/components/Title";
import styles from "./styles.module.scss";
import Answer from "../../components/Answer";
import { useDispatch, useSelector } from "react-redux";
import { actions, selectors } from "@/store";
import { sleep } from "@/services/date";
import { useNavigate } from "react-router-dom";
import routes from "@/routes";
import { answerTimeOut } from "../../data";
import { useTranslations } from "@/hooks/translations";
import { ELocalesPlacement } from "@/locales";
import { useMemo } from "react";
import { useSession } from "@/hooks/session/useSession";
import { IAnswersSessionCompatibilityV4 } from "@/api/resources/Session";
import { ESourceAuthorization } from "@/api/resources/User";

function ComplexRelationshipAspect() {
  const { translate } = useTranslations(ELocalesPlacement.CompatibilityV4);
  const { updateSession } = useSession();
  const navigate = useNavigate();
  const dispatch = useDispatch();
  const { complexRelationshipAspect } = useSelector(
    selectors.selectCompatibilityV4Answers
  );

  const answers: {
    id: IAnswersSessionCompatibilityV4["complex_relationship_aspect"];
    title: string;
  }[] = useMemo(
    () => [
      {
        id: "understanding",
        title: translate("/complex-relationship-aspect.answer1"),
      },
      {
        id: "emotions",
        title: translate("/complex-relationship-aspect.answer2"),
      },
      {
        id: "views",
        title: translate("/complex-relationship-aspect.answer3"),
      },
      {
        id: "conflicts",
        title: translate("/complex-relationship-aspect.answer4"),
      },
    ],
    [translate]
  );

  const handleClick = async (id: IAnswersSessionCompatibilityV4["complex_relationship_aspect"]) => {
    dispatch(actions.compatibilityV4Answers.update({ complexRelationshipAspect: id }));
    updateSession({
      answers: {
        complex_relationship_aspect: id,
      },
    }, ESourceAuthorization["aura.compatibility.v4"]);
    if (id !== complexRelationshipAspect) await sleep(answerTimeOut);

    return navigate(routes.client.compatibilityV4StressResponse());
  };

  return (
    <div className={styles.container}>
      <Title variant="h2" className={styles.title}>
        {translate("/complex-relationship-aspect.title")}
      </Title>
      {answers.map((answers, index) => (
        <Answer
          key={index}
          answer={answers}
          isSelected={complexRelationshipAspect === answers.id}
          onClick={() => handleClick(answers.id)}
        />
      ))}
    </div>
  );
}

export default ComplexRelationshipAspect;
